<template>
  <li>
    <h4>{{ name }}</h4>
    <input :value="name" @input="handleUpdate" />
    <ul>
      <li v-for="(action, index) in actions" :key="index">
        {{ action }}
      </li>
    </ul>
  </li>
</template>

<script>
import { computed } from "vue";

export default {
  name: "StatesComponent",
  props: {
    state: {
      type: Object,
      required: true
    }
  },
  setup(props, { emit }) {
    const name = computed(() => props.state.name);
    const actions = computed(() =>
      Object.keys(props.state).filter(
        action => !["name", "path", "view", "color"].includes(action)
      )
    );
    const handleRemove = () => emit("remove", props.state.id);
    const handleUpdate = event => {
      emit(
        "update",
        Object.assign({}, props.state, { name: event.target.value })
      );
    };
    return {
      name,
      actions,
      handleRemove,
      handleUpdate
    };
  }
};
</script>
